; #########################################################################
; File:       Child15.asm
; #########################################################################
      .586                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################
      include \masm32\include\windows.inc
      include \masm32\macros\macros.asm
      
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\winmm.inc           ; som      
;..............................................      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\winmm.lib            ; som      
;**************************************************************************
WinMain         proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc         proto :DWORD,:DWORD,:DWORD,:DWORD

CloseExecMsg    proto
OpenExecMsg     proto :DWORD
WndProcW        proto :DWORD,:DWORD,:DWORD,:DWORD
WndProcZ        proto :DWORD,:DWORD,:DWORD,:DWORD

PasMsgPr        proto :DWORD,:DWORD
PrPasMsg        proto :DWORD,:DWORD
CloseTimer      proto :DWORD,:DWORD,:DWORD,:DWORD

;**************************************************************************

; defined in resource file
;
.const
IDM_Open1       equ 1000
IDM_Open2       equ 1001
IDM_Open3       equ 1002

IDM_Close1      equ 1010

IDM_End         equ 2000
;**************************************************************************
;                          This is to TEST the effect
; Styles:
; *******
;          WS_SYSMENU       means the window has Close    button
;          WS_MINIMIZEBOX     "                  Minimize button
;          WS_MAXIMIZEBOX     "                  Maximize button
;          
; WS_POPUPWINDOW = WS_POPUP or WS_SYSMENU or WS_BORDER 
; WS_CAPTION     = WS_BORDER with title bar
;
;
WS_POPUPCLOSE0  equ WS_POPUP 
WS_POPUPCLOSE1  equ WS_POPUP or WS_SYSMENU
WS_POPUPCLOSE2  equ WS_POPUP or WS_BORDER

WS_POPUPTITLE   equ WS_POPUP or WS_CAPTION 
WS_POPUPCLOSE   equ WS_POPUP or WS_CAPTION or WS_SYSMENU
WS_POPUPMAX     equ WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_MAXIMIZEBOX
WS_POPUPMIN     equ WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX
WS_POPUPMINMAX  equ WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX

WS_CHILD0       equ WS_CHILD or WS_VISIBLE
WS_CHILD1       equ WS_CHILD or WS_BORDER or WS_VISIBLE
WS_CHILD2       equ WS_CHILD or WS_CAPTION or WS_VISIBLE
WS_CHILD3       equ WS_CHILD or WS_CAPTION or WS_VISIBLE or WS_MAXIMIZEBOX

WS_OVERLAPPEDCLOSE    equ WS_OVERLAPPED or WS_SYSMENU
WS_OVERLAPPEDMIN      equ WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX
WS_OVERLAPPEDMAX      equ WS_OVERLAPPED or WS_SYSMENU or WS_MAXIMIZEBOX
WS_OVERLAPPEDMINMAX   equ WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
; 
; Main window position
;
MAIN_X          equ 140
MAIN_Y          equ 100
CHILD_W         equ 280
; ##############################################################################################
.data
align 4
_MenuName       db "Menu1", 0                   ; definido em rsrc.rc
align 4
_WaveName7      db 'TDWave7', 0
;...............................................
align 4
_ClassName      db "WndClass", 0
align 4
_DisplayName    db "Child 15", 0
align 4
_hWnd           dd 0
_hInstance      dd 0
;......................
_ClientLeftX    dd 0
_ClientTopY     dd 0
_ClientRightX   dd 0
_ClientBottomY  dd 0
;++++++++++++++++++++++++++++++++++++++++++++++++++++
align 4
_ClassChild      db "WinChild", 0           ; class name
align 4
_MsgExecMsg     db 'Child Window', 0
align 4
_hChildWnd      dd 0
                ;
_WidthStr       dd 0
                dd 0
;....................................................
;               Messages
;
_pPasMsg        dd 0            ; message pointer

align 4
                db 17
_rMsg           db 'Programming error'

                db 17
_Msg0           db 'Programming error'

                db 9
_Msg1           db 'Message 1'
                db 9
_Msg2           db 'Message 2'
                db 9
_Msg3           db 'Message 3'
align 4
                dd offset _Msg0
                dd 3                ; number of messages
_TblExecMsg     dd offset _Msg1
                dd offset _Msg2
                dd offset _Msg3

_fnomove        dd 0
;....................................................
align 4
                db 255
_ErrorString    db 256 dup (0)

.data?
_hDC            dd ?
_ps     PAINTSTRUCT <?>
; #########################################################################
.code
; -----------------------------------------------------------------------
align 16
start:          invoke GetModuleHandle, NULL 
                mov    _hInstance, eax

                invoke   WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
                invoke   ExitProcess, eax       
; #########################################################################
;                               procedures
; ########################################################################
align 16
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov   wc.cbSize,         sizeof WNDCLASSEX
        mov   wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov   wc.lpfnWndProc,    offset WndProc      
        mov   wc.cbClsExtra,     NULL
        mov   wc.cbWndExtra,     NULL
        push  hInst
	  pop   wc.hInstance
        mov   wc.hIcon, NULL
        mov   wc.hIconSm, NULL        
        mov   wc.hbrBackground, COLOR_BTNFACE+1      ; system color
        mov   wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        mov   wc.lpszClassName, offset _ClassName    ; window class name        
        invoke LoadCursor, NULL, IDC_ARROW           ; system cursor
        mov   wc.hCursor, eax

        invoke RegisterClassEx, ADDR wc              ; register the window class
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDMIN,             
                              MAIN_X, MAIN_Y, 500, 350,
                              NULL, NULL, hInst, NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ########################################################################
align 16
WndProc         proc    hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD
                
                SWITCH  iMsg
                CASE    WM_SIZE
                ;
                ;  Client region
                ; ----------------
                invoke  GetClientRect, hWnd, addr _ClientLeftX
;                 
                CASE    WM_COMMAND
                ;=============== menu commands =======================
                     switch wParam  
                     case IDM_Open1
                        invoke  OpenExecMsg, 1

                     case IDM_Open2
                        invoke  OpenExecMsg, 2

                     case IDM_Open3
                        invoke  OpenExecMsg, 0          

                     case IDM_Close1
                        call    CloseExecMsg
                        
                     case IDM_End
                        invoke   SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL
                ;============= end menu commands =====================
                     endsw
; 
                CASE    WM_CLOSE
                     invoke  PostQuitMessage, NULL

                CASE    WM_DESTROY

; 
                DEFAULT
                   invoke  DefWindowProc, hWnd, iMsg, wParam, lParam
                   ret
                ENDSW
                ;
                xor     eax, eax
                ret
WndProc         endp
; #############################################################################
align 16
OpenExecMsg         proc    NMsg:DWORD
                    LOCAL   wc :WNDCLASSEX
                    pushfd
                    pushad
                    ;
                    cmp     _hChildWnd, 0
                    jne     _eOpenExecMsg

                    mov     _pPasMsg, 0
;......................................................
	              mov      wc.cbSize,      SIZEOF WNDCLASSEX
                    mov      wc.style,       CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW  
    	              ;mov      wc.lpfnWndProc, offset WndProcW
    	              mov      wc.lpfnWndProc, offset WndProcZ    
        	        mov      wc.cbClsExtra,  NULL
	              mov      wc.cbWndExtra,  NULL
	              push     _hInstance
	              pop      wc.hInstance
        	        mov      wc.hbrBackground, COLOR_BACKGROUND+1    ; COLOR_WINDOW+1        
	              mov      wc.lpszMenuName, NULL                   
	              mov      wc.lpszClassName, OFFSET _ClassChild    ; name of windows class
                    mov      wc.hIcon, NULL
        	        mov      wc.hCursor, NULL
                    mov      wc.hIconSm, NULL
                    invoke   RegisterClassEx, addr wc
;......................................................
                    invoke  CreateWindowEx, WS_EX_LEFT,                     ; Extended Style
                                    offset _ClassChild,                     ; Class name
                                    offset _MsgExecMsg,                     ; Title
                                    WS_CHILD2,                              ; Style
                                    80, 120, CHILD_W, 80,                   ; X,Y,W,H
                                    _hWnd, 0, _hInstance, 0 
                    mov     _hChildWnd, eax
                    ;
                    cmp     eax, NULL
                    jne     @F

                    call    DisplayError
                    jmp     _eOpenExecMsg
;--------------------------------------------------
@@:                 mov     edx, offset _TblExecMsg             ; message table
                    mov     eax, dword ptr [edx - 8]            ; pointer to error

                    mov     ecx, NMsg
                    cmp     ecx, 0
                    je      @F

                    cmp     ecx, dword ptr [edx - 4]            ; number of messages
                    ja      @F
                    
                    dec     ecx
                    mov     eax, dword ptr [edx + ecx * 4]
                    ;
@@:                 mov     _pPasMsg, eax
;---------------------------------------------------                    
                    invoke   ShowWindow, _hChildWnd, SW_SHOW
                    invoke   UpdateWindow, _hChildWnd

;####################
invoke    SetTimer, _hChildWnd, 7200, 800, offset CloseTimer
;####################
_eOpenExecMsg:      popad
                    popfd
                    ret
OpenExecMsg         endp
; ----------------------------------------------------------------------------------------------
align 16
CloseTimer          proc     hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

                    invoke    SendMessage, _hChildWnd, WM_CLOSE, 0, 0                    
                    ;invoke   DestroyWindow, _hChildWnd
                    mov      _hChildWnd, 0                     
                    ;
                    ; do We need to KillTimer ?
                    ;
                    invoke   KillTimer, hWnd, 7200
@@:                 ret
CloseTimer          endp
; ----------------------------------------------------------------------------------
;
; This structure is in Windows.inc
; --------------------------------
;WINDOWPOS STRUCT
;  hwnd              DWORD ?   ; window handle
;  hWndInsertAfter   DWORD ?
;  x                 DWORD ?
;  y                 DWORD ?
;  lx                DWORD ?
;  cy                DWORD ?
;  flags             DWORD ?  ; SWP_NOMOVE   Retains the current position 
                              ;             (ignores the x and y parameters).
;WINDOWPOS ENDS
;
align 16
WndProcW            proc    hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

                    SWITCH iMsg
                    CASE WM_WINDOWPOSCHANGING

                    cmp     _fnomove, 1
                    je      short @F

                    mov     _fnomove, 1
                    jmp     _eWndProcW
                    
@@:                     mov     edx, lParam         ; pointer to WINDOWPOS struc
                        mov     [edx].WINDOWPOS.flags, SWP_NOMOVE
                    
                    CASE WM_PAINT

                       cmp     _pPasMsg, 0
                       je      _eWndProcW

                       ;invoke   PasMsgPr, hWnd, _pPasMsg
                       invoke   PrPasMsg, hWnd, _pPasMsg
                       
                    CASE WM_CLOSE
                       ;invoke  PlaySound, addr _WaveName7, _hInstance, 40005h
                       invoke   DestroyWindow,  hWnd
                       mov     _hChildWnd, 0

                    CASE WM_DESTROY
                       ; 
                       ; Reset this Flag
                       ; 
                       mov     _fnomove, 0

                    DEFAULT
_eWndProcW:            invoke  DefWindowProc, hWnd, iMsg, wParam, lParam
                       ret
                    ENDSW
                    ;
                    xor     eax, eax
                    ret
WndProcW            endp
; ----------------------------------------------------------------------------------
;
; This structure is in Windows.inc
; --------------------------------
;WINDOWPOS STRUCT
;  hwnd              DWORD ?   ; window handle
;  hWndInsertAfter   DWORD ?
;  x                 DWORD ?
;  y                 DWORD ?
;  lx                DWORD ?
;  cy                DWORD ?
;  flags             DWORD ?  ; SWP_NOMOVE   Retains the current position 
                              ;             (ignores the x and y parameters).
;WINDOWPOS ENDS
;
align 16
WndProcZ            proc    hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

                    SWITCH iMsg
                    CASE WM_WINDOWPOSCHANGING

                    cmp     _fnomove, 1
                    je      short @F

                    mov     _fnomove, 1
                    jmp     _eWndProcZ
                    
@@:                     mov     edx, lParam         ; pointer to WINDOWPOS struc
                        mov     [edx].WINDOWPOS.flags, SWP_NOMOVE
                    
                    CASE WM_PAINT

                       cmp     _pPasMsg, 0
                       je      _eWndProcZ
                    ;   
                    invoke   BeginPaint, hWnd, addr _ps     ;ebx
                    mov      _hDC, eax

                    invoke   SetTextColor, _hDC, Yellow      
                    invoke   SetBkMode, _hDC, TRANSPARENT

                    ;*****************************************
                    mov      eax, _pPasMsg                      ;pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   GetTextExtentPoint32, _hDC, eax, edx, addr _WidthStr
                    mov      edx, CHILD_W
                    sub      edx, _WidthStr
                    shr      edx, 1
                    mov      _WidthStr, edx
                    ;*****************************************
                    mov      eax, _pPasMsg                      ;pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   TextOut, _hDC, _WidthStr, 20, eax, edx
                    ;
                    invoke   EndPaint, hWnd, addr _ps       ;ebx                    
                    ;
                       
                    CASE WM_CLOSE
                       ;invoke  PlaySound, addr _WaveName7, _hInstance, 40005h
                       invoke   DestroyWindow,  hWnd
                       mov     _hChildWnd, 0

                    CASE WM_DESTROY
                       ; 
                       ; Reset this Flag
                       ; 
                       mov     _fnomove, 0

                    DEFAULT
_eWndProcZ:            invoke  DefWindowProc, hWnd, iMsg, wParam, lParam
                       ret
                    ENDSW
                    ;
                    xor     eax, eax
                    ret
WndProcZ            endp
; 
align 16
CloseExecMsg        proc
                    pushfd

                    cmp     _hChildWnd, 0
                    je      @F
                    
                    invoke    SendMessage, _hChildWnd, WM_CLOSE, 0, 0 

                    mov     _hChildWnd, 0
                    
@@:                 popfd
                    ret
CloseExecMsg        endp
; 
align 16
PasMsgPr            proc    hWnd:DWORD, pPas:DWORD    
                    LOCAL   hDC:DWORD 
                    ;
                    invoke   GetDC, hWnd
                    mov      hDC, eax

                    invoke   SetTextColor, hDC, Yellow      
                    invoke   SetBkMode, hDC, TRANSPARENT

                    ;**************************************************************
                    mov      eax, pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   GetTextExtentPoint32, hDC, eax, edx, addr _WidthStr
                    mov      edx, CHILD_W
                    sub      edx, _WidthStr
                    shr      edx, 1
                    mov      _WidthStr, edx
                    ;**************************************************************
                    mov      eax, pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   TextOut, hDC, _WidthStr, 20, eax, edx                      
                    ;
                    invoke   ReleaseDC, hWnd, hDC                    
                    ;
                    ret
PasMsgPr            endp
; 
align 16
PrPasMsg            proc    hWnd:DWORD, pPas:DWORD    
                    ;LOCAL   hDC:DWORD
                    ;LOCAL   ps:PAINTSTRUCT 
                    ;
                    ;push     ebx
                    ;lea      ebx, ps
                    invoke   BeginPaint, hWnd, addr _ps     ;ebx
                    mov      _hDC, eax

                    invoke   SetTextColor, _hDC, Yellow      
                    invoke   SetBkMode, _hDC, TRANSPARENT

                    ;**************************************************************
                    mov      eax, pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   GetTextExtentPoint32, _hDC, eax, edx, addr _WidthStr
                    mov      edx, CHILD_W
                    sub      edx, _WidthStr
                    shr      edx, 1
                    mov      _WidthStr, edx
                    ;**************************************************************
                    mov      eax, pPas 
                    movzx    edx, byte ptr [eax - 1]
                    invoke   TextOut, _hDC, _WidthStr, 20, eax, edx
                    ;
                    invoke   EndPaint, hWnd, addr _ps       ;ebx                    
                    ;
                    ;pop      ebx
                    ret
PrPasMsg            endp
; 
align 16
DisplayError    proc
                push    eax
                push    ecx
                push    edx
                ;
                invoke  GetLastError
                test    eax, eax
                jz      @F                
                ;
                invoke  FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, eax, 0, 
                                        offset _ErrorString, 255, 0
                ;                                        
                invoke  MessageBox, 0, offset _ErrorString, 0, 0
                ;
@@:             pop     edx
                pop     ecx
                pop     eax
                ret
DisplayError    endp
; 
end start
